#!/usr/bin/env luajit
require("utils")
require("unionfind")

local hm = {}
for line in io.lines(arg[3]) do
	local row = {}
	for c in chars(line) do
		table.insert(row, tonumber(c))
	end
	table.insert(hm, row)
end

local function get(r, c)
	return (hm[r] or {})[c] or 9
end

local union = unionfind()
for r, row in pairs(hm) do
	for c, col in pairs(row) do
		if col ~= 9 then
			if get(r - 1, c) ~= 9 then
				union:makeset(r, c)
				union:makeset(r - 1, c)
				union:union(r, c, r - 1, c)
			end
			if get(r, c - 1) ~= 9 then
				union:makeset(r, c)
				union:makeset(r, c - 1)
				union:union(r, c, r, c - 1)
			end
		end
	end
end

local sizes = union:sizes()
table.sort(sizes)
print(sizes[#sizes] * sizes[#sizes - 1] * sizes[#sizes - 2])
